
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Shipping_methodsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const shipping_methods = await db.shipping_methods.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        carrier_name: data.carrier_name
        ||
        null
            ,
            
        service_level: data.service_level
        ||
        null
            ,
            
        base_fee: data.base_fee
        ||
        null
            ,
            
        fee_per_kg: data.fee_per_kg
        ||
        null
            ,
            
        estimated_days_min: data.estimated_days_min
        ||
        null
            ,
            
        estimated_days_max: data.estimated_days_max
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return shipping_methods;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const shipping_methodsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                carrier_name: item.carrier_name
            ||
            null
            ,
            
                service_level: item.service_level
            ||
            null
            ,
            
                base_fee: item.base_fee
            ||
            null
            ,
            
                fee_per_kg: item.fee_per_kg
            ||
            null
            ,
            
                estimated_days_min: item.estimated_days_min
            ||
            null
            ,
            
                estimated_days_max: item.estimated_days_max
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const shipping_methods = await db.shipping_methods.bulkCreate(shipping_methodsData, { transaction });

        // For each item created, replace relation files
        

        return shipping_methods;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const shipping_methods = await db.shipping_methods.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.carrier_name !== undefined) updatePayload.carrier_name = data.carrier_name;
        
        
        if (data.service_level !== undefined) updatePayload.service_level = data.service_level;
        
        
        if (data.base_fee !== undefined) updatePayload.base_fee = data.base_fee;
        
        
        if (data.fee_per_kg !== undefined) updatePayload.fee_per_kg = data.fee_per_kg;
        
        
        if (data.estimated_days_min !== undefined) updatePayload.estimated_days_min = data.estimated_days_min;
        
        
        if (data.estimated_days_max !== undefined) updatePayload.estimated_days_max = data.estimated_days_max;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await shipping_methods.update(updatePayload, {transaction});

        
        

        
        

        

        return shipping_methods;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const shipping_methods = await db.shipping_methods.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of shipping_methods) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of shipping_methods) {
                await record.destroy({transaction});
            }
        });


        return shipping_methods;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const shipping_methods = await db.shipping_methods.findByPk(id, options);

        await shipping_methods.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await shipping_methods.destroy({
            transaction
        });

        return shipping_methods;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const shipping_methods = await db.shipping_methods.findOne(
            { where },
            { transaction },
        );

        if (!shipping_methods) {
            return shipping_methods;
        }

        const output = shipping_methods.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.orders_shipping_method = await shipping_methods.getOrders_shipping_method({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'shipping_methods',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.carrier_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'shipping_methods',
                        'carrier_name',
                        filter.carrier_name,
                    ),
                };
            }
            
            if (filter.service_level) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'shipping_methods',
                        'service_level',
                        filter.service_level,
                    ),
                };
            }
            

            
            

            
            if (filter.base_feeRange) {
                const [start, end] = filter.base_feeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    base_fee: {
                    ...where.base_fee,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    base_fee: {
                    ...where.base_fee,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.fee_per_kgRange) {
                const [start, end] = filter.fee_per_kgRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    fee_per_kg: {
                    ...where.fee_per_kg,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    fee_per_kg: {
                    ...where.fee_per_kg,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.estimated_days_minRange) {
                const [start, end] = filter.estimated_days_minRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    estimated_days_min: {
                    ...where.estimated_days_min,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    estimated_days_min: {
                    ...where.estimated_days_min,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.estimated_days_maxRange) {
                const [start, end] = filter.estimated_days_maxRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    estimated_days_max: {
                    ...where.estimated_days_max,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    estimated_days_max: {
                    ...where.estimated_days_max,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.shipping_methods.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'shipping_methods',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.shipping_methods.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

